import base64
import json
import sys
import struct

class StubFlasher:
    def __init__(self, json_path):
        with open(json_path) as json_file:
            stub = json.load(json_file)

        self.text = base64.b64decode(stub["text"])
        self.text_start = stub["text_start"]
        self.entry = stub["entry"]

        try:
            self.data = base64.b64decode(stub["data"])
            self.data_start = stub["data_start"]
        except KeyError:
            self.data = None
            self.data_start = None

        self.bss_start = stub.get("bss_start")

def main(argv):
 stub = StubFlasher(argv[1])
 s=struct.pack("<BBBBI",0xe9,3,0,0,stub.entry)
 s+=struct.pack("<II",stub.text_start,len(stub.text))
 s+=stub.text
 s+=struct.pack("<II",stub.data_start,len(stub.data))
 s+=stub.data
 s+=struct.pack("<II",stub.bss_start,0)
 
 with open(argv[2],"wb") as f:
  f.write(s)

if __name__ == "__main__":
    main(sys.argv)
